eventex/subscriptions/urls.py
from django.conf.urls import url
from eventex.subscriptions.views import new, detail

urlpatterns = [
    url(r'^$', new, name='new'),
    url(r'^(\d+)/$', detail, name='detail'),
]

eventex/urls.py
from django.conf.urls import include, url
from django.contrib import admin
from eventex.core.views import home, speaker_detail, talk_list

urlpatterns = [
    url(r'^$', home, name='home'),
    url(r'^inscricao/', include('eventex.subscriptions.urls',
                                namespace='subscriptions')),
    url(r'^palestras/$', talk_list, name='talk_list'),
    url(r'^palestrantes/(?P<slug>[\w-]+)', speaker_detail, name='speaker_detail'),
    url(r'^admin/', include(admin.site.urls)),
]

eventex/core/models.py
from django.db import models
from django.shortcuts import resolve_url as r
from eventex.core.managers import KindQuerySet, PeriodManager


class Speaker(models.Model):
    name = models.CharField('nome', max_length=255)
    slug = models.SlugField('slug')
    photo = models.URLField('foto')
    website = models.URLField('website', blank=True)
    description = models.TextField('descrição', blank=True)

    class Meta:
        verbose_name = 'palestrante'
        verbose_name_plural = 'palestrantes'


    def __str__(self):
        return self.name

    def get_absolute_url(self):
        return r('speaker_detail', slug=self.slug)


class Contact(models.Model):
    EMAIL = 'E'
    PHONE = 'P'

    KINDS = (
        (EMAIL, 'Email'),
        (PHONE, 'Telefone'),
    )

    speaker = models.ForeignKey('Speaker', verbose_name='palestrante')
    kind = models.CharField('tipo', max_length=1, choices=KINDS)
    value = models.CharField('valor', max_length=255)

    objects = KindQuerySet.as_manager()

    class Meta:
        verbose_name = 'contato'
        verbose_name_plural = 'contatos'

    def __str__(self):
        return self.value


class Activity(models.Model):
    title = models.CharField('título', max_length=200)
    start = models.TimeField('início', blank=True, null=True)
    description = models.TextField('descrição', blank=True)
    speakers = models.ManyToManyField('Speaker', verbose_name='palestrantes', blank=True)

    objects = PeriodManager()

    class Meta:
        abstract = True
        verbose_name = 'palestra'
        verbose_name_plural = 'palestras'

    def __str__(self):
        return self.title

class Talk(Activity):
    pass


class Course(Activity):
    slots = models.IntegerField()

    class Meta:
        verbose_name_plural = 'cursos'
        verbose_name = 'curso'

eventex/subscriptions/models.py
from django.db import models
import uuid # agregado

from eventex.subscriptions.validators import validate_cpf


class Subscription(models.Model):
    name = models.CharField('nome',max_length=100)
    cpf = models.CharField('CPF', max_length=11, validators=[validate_cpf])
    email = models.EmailField('e-mail', blank=True)
    phone = models.CharField('telefone', max_length=20, blank=True)
    created_at = models.DateTimeField('criado em', auto_now_add=True)
    paid = models.BooleanField('pago', default=False)

    class Meta:
        verbose_name_plural = 'inscrições'
        verbose_name = 'incrição'
        ordering = ('-created_at',)

    def __str__(self):
        return self.name

eventex/subscriptions/forms.py
from django import forms
from django.core.exceptions import ValidationError

from eventex.subscriptions.models import Subscription
from eventex.subscriptions.validators import validate_cpf


class SubscriptionFormOld(forms.Form):
    name = forms.CharField(label='Nome')
    cpf = forms.CharField(label='CPF', validators=[validate_cpf])
    email = forms.EmailField(label='Email', required=False)
    phone = forms.CharField(label='Telefone', required=False)

    def clean_name(self): # 'clean_' + nome_do_campo
        name = self.cleaned_data['name']
        words = [w.capitalize() for w in name.split()]
        return ' '.join(words)

    def clean(self):
        if not self.cleaned_data.get('email') and not self.cleaned_data.get('phone'):
            raise ValidationError('Informe seu e-mail ou telefone')

        return self.cleaned_data


class SubscriptionForm(forms.ModelForm):
    class Meta:
        model = Subscription
        fields = ['name', 'cpf', 'email', 'phone']

    def clean_name(self): # 'clean_' + nome_do_campo
        name = self.cleaned_data['name']
        words = [w.capitalize() for w in name.split()]
        return ' '.join(words)

    def clean(self):
        self.cleaned_data = super().clean()

        if not self.cleaned_data.get('email') and not self.cleaned_data.get('phone'):
            raise ValidationError('Informe seu e-mail ou telefone')

        return self.cleaned_data

eventex/core/views.py
from django.shortcuts import render, get_object_or_404
from eventex.core.models import Speaker, Talk, Course


def home(request):
    speakers = Speaker.objects.all()
    return render(request, 'index.html', {'speakers': speakers})


def speaker_detail(request, slug):
    speaker = get_object_or_404(Speaker, slug=slug)
    return render(request, 'core/speaker_detail.html', {'speaker': speaker})


def talk_list(request):
    context = {
        'morning_talks': Talk.objects.at_morning(),
        'afternoon_talks': Talk.objects.at_afternoon(),
        'courses': Course.objects.all(),
    }
    return render(request, 'core/talk_list.html', context)

eventex/subscriptions/views.py
from django.conf import settings
from django.core import mail
from django.http import HttpResponseRedirect, Http404
from django.shortcuts import render, resolve_url as r
from django.template.loader import render_to_string
from eventex.subscriptions.forms import SubscriptionForm
from eventex.subscriptions.models import Subscription


def new(request):
    if request.method == 'POST':
        return create(request)

    return empty_form(request)


def empty_form(request):
    return render(request, 'subscriptions/subscription_form.html',
                  {'form': SubscriptionForm()})


def create(request):
    form = SubscriptionForm(request.POST)

    if not form.is_valid():
        return render(request, 'subscriptions/subscription_form.html',
                      {'form': form})

    subscription = form.save()

    # Send subscription email
    _send_mail('Confirmação de inscrição',
               settings.DEFAULT_FROM_EMAIL,
               subscription.email,
               'subscriptions/subscription_email.txt',
               {'subscription': subscription})

    return HttpResponseRedirect(r('subscriptions:detail', subscription.pk))



def detail(request, pk):
    try:
        subscription = Subscription.objects.get(pk=pk)
    except Subscription.DoesNotExist:
        raise Http404


    return render(request, 'subscriptions/subscription_detail.html',
                  {'subscription': subscription})


def _send_mail(subject: object, from_: object, to: object, template_name: object, context: object) -> object:
    body = render_to_string(template_name, context)
    mail.send_mail(subject, body, from_, [from_, to])

eventex/core/templates/base.html
{% load static %}
<!DOCTYPE html>
<html>
	<head>
        <title>{% block title %}Eventex - O maior encontro hacker do mundo!{% endblock title %}</title>

        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
        <meta name="description" content="Eventex - O maior encontro hacker do mundo!">
        <meta name="author" content="wttd">
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />

        <!-- Favicon -->
        <link rel="shortcut icon" href="{% static 'img/favicon.ico' %}">

        <!-- CSS -->
        <link rel="stylesheet" href="{% static 'css/font-awesome.min.css' %}">
        <link rel="stylesheet" href="{% static 'css/basalstyle/style.min.css' %}">
        <link rel="stylesheet" href="{% static 'css/main.css' %}">

        <link href='http://fonts.googleapis.com/css?family=Economica:400,700' rel='stylesheet' type='text/css'>
	</head>

	<body>
        <div class="header-frame row">
            {% include 'nav.html' only %}
        </div>

        {% block content %}
        {% endblock content %}


    </body>
</html>

eventex/core/templates/core/speaker_detail.html
{% extends 'base.html' %}

{% block content %}
<section>
    <div class="speakers content row padding-bottom-3 desktop-8 container">
        <h2>
            <a href="{{ speaker.website }}">{{ speaker.name }}</a>
        </h2>
        <img class="photo" src="{{ speaker.photo }}">
        <p>
            {{ speaker.description|linebreaks }}
        </p>
    </div>
</section>
{% endblock content %}

eventex/core/templates/core/talk_list.html
{% extends 'base.html' %}

{% block content %}
<section>
    <div class="talks content row padding-bottom-3 desktop-12 container">
        <h2>Manhã</h2>
        {% for talk in morning_talks %}
            {% include 'core/talk_list_snippet.html' with talk=talk only %}
            {% empty %}
            <p>Ainda não existem palestras de manhã</p>
        {% endfor %}

        <h2>Tarde</h2>
        {% for talk in afternoon_talks %}
            {% include 'core/talk_list_snippet.html' with talk=talk only %}
            {% empty %}
            <p>Ainda não existem palestras de tarde</p>
        {% endfor %}


        <h2>Mini-cursos</h2>
        {% for course in courses %}
            {% include 'core/talk_list_snippet.html' with talk=course only %}
            {% empty %}
            <p>Ainda não existem cursos</p>
        {% endfor %}


    </div>
</section>
{% endblock content %}

eventex/core/templates/core/talk_list_snippet.html
<h3>{{ talk.start }} - {{ talk.title }}</h3>
<h4>Por
    {% for speaker in talk.speakers.all %}
        <a href="{{ speaker.get_absolute_url }}">{{ speaker.name }}</a>
    {% endfor %}
</h4>
<p>{{ talk.description }}</p>

eventex/core/templates/index.html
{% load static %}
<!DOCTYPE html>
<html>
	<head>
        <title>Eventex - O maior encontro hacker do mundo!</title>

        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
        <meta name="description" content="Eventex - O maior encontro hacker do mundo!">
        <meta name="author" content="wttd">
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />

        <!-- Favicon -->
        <link rel="shortcut icon" href="{% static 'static/img/favicon.ico' %}">

        <!-- CSS -->
        <link rel="stylesheet" href="{% static 'css/font-awesome.min.css'%}">
        <link rel="stylesheet" href="{% static 'css/basalstyle/style.min.css'%}">
        <link rel="stylesheet" href="{% static 'css/main.css' %}">

        <link href='http://fonts.googleapis.com/css?family=Economica:400,700' rel='stylesheet' type='text/css'>

        <script src="https://maps.googleapis.com/maps/api/js?v=3.exp"></script>


        <script src="{% static 'js/jquery-1.11.0.min.js'%}"></script>
        <script src="{% static 'js/jquery.stellar.min.js'%}"></script>
        <script src="{% static 'js/smooth-scroll.js'%}"></script>
        <script src="{% static 'js/retina-1.1.0.min.js'%}"></script>
        <script src="{% static 'js/main.js'%}"></script>

    </head>

	<body>

        <div class="header-frame header-frame-absolute  row">
            {% include 'nav.html' only %}
        </div>

      	<!-- TOP -->
        <section id="top" data-stellar-background-ratio="0.5">
        	<div class="countdown text-align-center row desktop-12 container">
            	<h1 class="uppercase">Eventex</h1>
                <h3>Brasil</h3>
            </div>
        </section>

        <!-- OVERVIEW -->
        <section id="overview">
        	<div class="overview text-align-center row desktop-12 min-h-15 padding-top-2 container">
            	<i class="fa fa-5x fa-globe"></i>
            	<h2>A Conferência</h2>
                <p class="lead">A maior reunião de hackers do mundo.<br>Reunindo profissionais e entusiastas dos quatro <br>cantos do planeta, o <em>Eventex</em> é o lugar onde você precisa estar.</p>
            	<p><a class="btn-basic btn-blue" data-scroll href="#register">Garanta a sua vaga!</a></p>
            </div>
        </section>

        <section id="speakers">
            <div class="speakers text-align-center row desktop-8 padding-bottom-2 container">
                <h2>Palestrantes Convidados</h2>
                {% for speaker in speakers %}
                <div class="desktop-4">
                    <img src="{{ speaker.photo }}">
                    <h4>
                        <a href="{{ speaker.get_absolute_url }}">
                            {{ speaker.name }}
                        </a>
                    </h4>
                </div>
                {% endfor %}
            </div>
        </section>

        <!-- SPONSORS -->
        <section id="sponsors">
        	<div class="sponsors text-align-center row desktop-12 min-h-28 padding-bottom-2 container">

                <h2>Patrocinadores</h2>

                <h3>Gold</h3>
                <div class="sponsor-slider min-h-6">
                    <img class="img-responsive" src="{% static 'img/sponsor-gold-01.png' %}" alt="logo">
                    <img class="img-responsive" src="{% static 'img/sponsor-gold-02.png' %}" alt="logo">
                    <img class="img-responsive" src="{% static 'img/sponsor-gold-03.png' %}" alt="logo">

                </div>

                <h3>Silver</h3>
                <div class="sponsor-slider min-h-6 margin-bottom-1">
                	<img class="img-responsive" src="{% static 'img/sponsor-silver-01.png'%}" alt="logo">
                    <img class="img-responsive" src="{% static 'img/sponsor-silver-02.png'%}" alt="logo">
                    <img class="img-responsive" src="{% static 'img/sponsor-silver-03.png'%}" alt="logo">
                    <img class="img-responsive" src="{% static 'img/sponsor-silver-04.png'%}" alt="logo">
                    <img class="img-responsive" src="{% static 'img/sponsor-silver-05.png'%}" alt="logo">
                    <img class="img-responsive" src="{% static 'img/sponsor-silver-06.png'%}" alt="logo">
                </div>

                <h3>Seja um patrocinador</h3>
                <p>Interessado? Descubra as oportunidades e benefícios.</p>
                <a class="btn-basic btn-blue" href="mailto:contato@eventex.com.br?Subject=Patrocínio">informe-se</a>

            </div>
        </section>

        <!-- REGISTER -->
        <section id="register">
            <div class="register row">
                <div class="text-align-center row desktop-12 padding-top-2 min-h-14 container">
                	<h2>Inscrição</h2>
                	<h3>Inscrições abertas</h3>
                    <p>Fique à vontade para entrar em contato com a gente.<br>Teremos prazer em responder quaisquer dúvidas.</p>
                	<a class="btn-basic btn-blue" href="{% url 'subscriptions:new' %}">Inscreva-se já</a>
                </div>
            </div>
        </section>

        <!-- VENUE -->
        <section id="venue">
            <div class="row min-h-10">

                <div id="map-canvas"></div>
                <div class="row desktop-12 container">
                    <div class="venue row">
                        <div class="venue-address desktop-4 gutter">
                            <h2>Bar Samba Caffé</h2>
                            <p>Melhor que qualquer centro de convenções.</p>
                            <p class="address">
                                <i class="fa fa-2x fa-map-marker fa-inverse"></i>
                                Rua do Ouvidor 23, Centro<br>
                                Rio de Janeiro, RJ
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </section>

    </body>
</html>

eventex/core/templates/nav.html
<header class="header header-inline min-h-3 row desktop-12 container" role="banner">

    <div class="site-logo">
        <h1><a href="{% url 'home' %}" rel="home">Eventex</h1>
        <p class="site-description screen-reader-only">O maior encontro hacker do mundo!</p>
    </div>

    <nav class="nav-inline" role="navigation">
        <a href="javascript:void(0);" class="nav-mobile"><i class="fa fa-bars"></i></a>
        <ul>
            <li><a data-scroll href="{% url 'home' %}#overview">Conferência</a></li>
            <li><a data-scroll href="{% url 'talk_list' %}">Palestras</a></li>
            <li><a data-scroll href="{% url 'home' %}#speakers">Palestrantes</a></li>
            <li><a data-scroll href="{% url 'home' %}#sponsors">Patrocinadores</a></li>
            <li><a data-scroll href="{% url 'home' %}#register">Inscrição</a></li>
            <li><a data-scroll href="{% url 'home' %}#venue">Local</a></li>
        </ul>
    </nav>

</header>

eventex/subscriptions/templates/subscriptions/subscription_detail.html
{% extends 'base.html' %}

{% block content %}
<!-- OVERVIEW -->
<section>
    <div class="content row padding-bottom-3 desktop-12 container">
        <h1>Obrigada por se inscrever!</h1>
        <div class="desktop-6">
            <p>Estes foram os dados que você no forneceu em sua inscrição:</p>

            <ul>
                <li>Nome: {{ subscription.name }}</li>
                <li>CPF: {{ subscription.cpf }}</li>
                <li>Email: {{ subscription.email }}</li>
                <li>Telefone: {{ subscription.phone }}</li>
            </ul>

            <p>Em até 48 horas úteis, a nossa equipe entrará em contato com você para concluirmos a sua matrícula.</p>


        </div>
    </div>
</section>
{% endblock content %}

eventex/subscriptions/templates/subscriptions/subscription_form.html
{% extends 'base.html' %}

{% block content %}
<!-- OVERVIEW -->
<section>
    <div class="content row padding-bottom-3 desktop-12 container">
        <h1>Formulário de Inscrição</h1>
        <div class="desktop-6">
            <form action="." novalidate method="post">
                {% csrf_token %}
                {{ form.non_field_errors }}
                <div class="form-row label-block input-text">
                    <label for="{{ form.name.id_for_label }}">{{ form.name.label }}</label>
                    {{ form.name.errors }}
                    {{ form.name }}
                </div>
                <div class="form-row label-block input-text">
                    <label for="{{ form.cpf.id_for_label }}">{{ form.cpf.label }}</label>
                    {{ form.cpf.errors }}
                    {{ form.cpf }}
                </div>
                <div class="form-row label-block input-text">
                    <label for="{{ form.email.id_for_label }}">{{ form.email.label }}</label>
                    {{ form.email.errors }}
                    {{ form.email }}
                </div>
                <div class="form-row label-block input-text">
                    <label for="{{ form.phone.id_for_label }}">{{ form.phone.label }}</label>
                    {{ form.phone.errors }}
                    {{ form.phone }}
                </div>
                <p class="btn-row"><input type="submit" value="Enviar!"/></p>
            </form>
        </div>
    </div>
</section>
{% endblock content %}